
;TV's server version 3.10
;Copyright (c) 2014 - 2019, Tycho Veltmeijer.
;All rights reserved.

include 'register.inc'

hKey pointer 0
align 16
subKey db "Software\TV's software\TV's server v3",0
subkeyListenSession db 'ListenSessions',0
subkeyProtocol db 'Protocols',0
subkeyById db 'listById',0
subkeyByString db 'listByString',0
subkeyMudules db 'Modules',0
subkeyBlockedProtocols db 'BlockedProtocols',0
nameBindedProtocol db 'BindedToProtocols',0
nameListenSession db 'Name',0
;nameProtocolData db 'ProtocolData',0
nameProtocolType db 'ProtocolType',0
nameItemsPerRow db 'ItemsPerRow',0
dubbelePunt db ':',0


;------------------------------------------------------------------------------
;This function will prepare the register
;output: EAX: true / false
;------------------------------------------------------------------------------ `
PrepareSaveToDisk:
call denter

push 0                  ;no other subKeys
push 0                  ;no other subKeys
push 0                  ;no other subKeys
push subKey             ;the path we want to write in the register
if used is64
  mov rax,HKEY_LOCAL_MACHINE
  push rax
else
  push HKEY_LOCAL_MACHINE ;use key Local Machine
end if
push 1                  ;Create key if not exists
call OpenRegKey
mov [hKey],peax
xchg peax,pecx

call dleave
ret

;------------------------------------------------------------------------------
;This function will add a protocol to the blocked list
;input:
;  1:pointer InternalProtocolSession
;output: EAX: true / false
;------------------------------------------------------------------------------ `
SaveBlockedPluginToDisk:
call denter

sub pesp,264
mov pesi,pesp ;space on stack for the module name

mov pebx,pdword [pebp+psize*2] ;InternalProtocolSession
mov peax,pdword [pebx+psize*4] ;modstruct
mov peax,pdword [peax+psize]   ;hmodule

mov pebx,pdword [pebx+psize*2] ;copy protocolsession
mov pebx,pdword [pebx+psize]   ;protocolName

push 264-1 ;size
push pesi  ;buff
push peax  ;hmodule
call saveGetModuleFileName

;count string size
push pesi
call strlen

add pesi,peax ;(R/E)SI = pointer to end of filename string
mov pecx,peax ;ECX = size of filename string
std ;set direction downwards

findFileNameSavePluginDataToDisk:
  lodsb
  cmp al,'\'
  je foundNameSavePluginDataToDisk
  cmp al,'/'
  je foundNameSavePluginDataToDisk
loop findFileNameSavePluginDataToDisk

dec pesi
dec pesi

foundNameSavePluginDataToDisk:
cld ;set direction upwards
inc pesi
inc pesi

;Create string with format: Modulename:Protocolname
push 0
push pebx         ;protocol name
push 0x1          ;ASCII
push dubbelePunt  ;dubbele punt
push 0x1          ;ASCII
push pesi         ;module name
push 0x1          ;ASCII
call CreateOneStringA ;CreateOneString
mov pedi,peax

;--push peax
;--call StringW2A
;--xchg pedi,peax

;--push peax
;--call FreeMemLocation

push pebx
call strlen

;write itemsPerRow to registry
push REG_SZ                 ;push type for register
push peax                   ;datalen
push pebx                   ;data
push pedi                   ;protocol name
push 0                      ;SubSubSubSubKey
push 0                      ;SubSubSubKey
push 0                      ;SubSubKey
push subkeyBlockedProtocols ;SubKey
push [hKey]                 ;key already opent
call WriteRegEx

;free string with format string with format: Modulename:Protocolname
push pedi
call FreeMemLocation

call dleave
ret psize

;------------------------------------------------------------------------------
;This function will check if a protocol is blocked or not
;input:
;  1:pointer protocolname
;  2:pointer: modulename
;output: EAX: true / false
;------------------------------------------------------------------------------ `
IsPluginToBlocked:
call denter

mov pebx,pdword [pebp+psize*2]   ;protocolName
mov pesi,pdword [pebp+psize*3] ;modulename

;count string size
push pesi
call strlen

add pesi,peax ;(R/E)SI = pointer to end of filename string
mov pecx,peax ;ECX = size of filename string
std ;set direction downwards

findFileNameIsPluginToBlocked:
  lodsb
  cmp al,'\'
  je foundNameIsPluginToBlocked
  cmp al,'/'
  je foundNameIsPluginToBlocked
loop findFileNameIsPluginToBlocked

dec pesi
dec pesi

foundNameIsPluginToBlocked:
cld ;set direction upwards
inc pesi
inc pesi

;Create string with format: Modulename:Protocolname
push 0
push pebx         ;protocol name
push 0x1          ;ASCII
push dubbelePunt  ;dubbele punt
push 0x1          ;ASCII
push pesi         ;module name
push 0x1          ;ASCII
call CreateOneStringA ;CreateOneString
mov pedi,peax

;-push peax
;-call StringW2A
;-xchg pedi,peax

;-push peax
;-call FreeMemLocation

;get the value
push pedi                   ;protocol name
push 0                      ;SubSubSubSubKey
push 0                      ;SubSubSubKey
push 0                      ;SubSubKey
push subkeyBlockedProtocols ;SubKey
push pdword [hKey]          ;hkey
call ReadRegEx
test pecx,pecx
jnz endIsPluginToBlocked

push peax ;push value for FreeMemLocation call

;compair both strings
push peax
push pebx
call strcmp
mov pebx,peax ;save result

;free value
call FreeMemLocation

xor eax,eax
test pebx,pebx
jnz endIsPluginToBlocked ;return false

inc eax ;return true

endIsPluginToBlocked:
push peax ;save result

;free string with format string with format: Modulename:Protocolname
push pedi
call FreeMemLocation

pop peax ;restore result

call dleave
ret psize*2

;------------------------------------------------------------------------------
;This function will call function GetModuleFileName
;input:
;  1:hModule
;  2:buff
;  3:size
;output: EAX: true / false
;------------------------------------------------------------------------------ `
saveGetModuleFileName:
call denter
MakeStack

argpush 3,pdword [pebp+psize*4] ;size
argpush 2,pdword [pebp+psize*3] ;buff
argpush 1,pdword [pebp+psize*2] ;hModule
call [GetModuleFileNameA]

call dleave
ret psize*3

;------------------------------------------------------------------------------
;This function will save data to the disk (in this case to the register)
;input:
;  1:pointer name of protocol
;  2:integer Unique Id of the Listensession
;  3:flags
;    GDPD_NAME_IS_INTEGER (0x80)name is integer
;  4:name
;  5:data
;  6:len
;output: EAX: true / false
;------------------------------------------------------------------------------ `
SavePluginDataToDisk:
call denter

xor edx,edx
mov pebx,subkeyProtocol        ;subkey  'Protocols'
mov pecx,pdword [pebp+psize*2] ;(R/E)CX = protocol name
mov peax,pdword [pebp+psize*3] ;(R/E)AX = Unique Id of the Listensession
test peax,peax
jz noUniqueIdGiven

mov pebx,subkeyListenSession        ;subkey  'ListenSessions'

;create room on stack to convert the uniqueId to string
if used is32
  sub pesp,0xC
else
  sub rsp,0x28
end if
mov pedx,pesp ;(R/E)DX = pointer to string with unique number

push 0x10
push pedx
push peax ;the unique number
call IntToStr

noUniqueIdGiven:
mov pesi,subkeyByString
mov pedi,pdword [pebp+psize*5] ;name
mov peax,pdword [pebp+psize*4] ;flags
test peax,GDPD_NAME_IS_INTEGER
jz nameIsString

;create room on stack to convert the name to string
if used is32
  sub pesp,0xC
else
  sub rsp,0x28
end if
mov peax,pesp ;(R/E)DX = pointer to string with unique number

push 0x10
push peax
push pedi ;name
call IntToStr

mov pedi,pesp

mov pesi,subkeyById

nameIsString:
test pedx,pedx
jnz UniqueIdIsSet

xchg pedx,pesi ;swap the unique id (since it is not set) with the "listById" or "listByString" string
jmp UniqueIdIsNotSet

UniqueIdIsSet:
xchg pecx,pedx

UniqueIdIsNotSet:
push REG_BINARY
push pdword [pebp+psize*7]  ;datalen
push pdword [pebp+psize*6]  ;data
push pedi                   ;name of data
push pesi                   ;"listById" or "listByString" or null
push pedx                   ;use protocol name as sub key (or no subkey if unique id = 0)
push pecx                   ;use Unique Id as sub key (or protocol name if unique id = 0)
push pebx                   ;use "ListenSessions" or "Protocols" as subkey
push [hKey]                 ;key already opent

mov peax,WriteRegEx
mov pecx,WriteListReg
test pdword [pebp+psize*4],GDPD_IS_LIST
cmovnz peax,pecx

call peax

call dleave
ret psize*6

;------------------------------------------------------------------------------
;This function will save data to the disk (in this case to the register)
;input:
;  1:pointer name of protocol
;  2:integer Unique Id of the Listensession
;  3:flags
;    GDPD_NAME_IS_INTEGER (0x80)name is integer
;  4:name
;output: EAX: true / false
;------------------------------------------------------------------------------ `
RemovePluginDataFromDisk:
call denter

xor edx,edx
mov pebx,subkeyProtocol        ;subkey  'Protocols'
mov pecx,pdword [pebp+psize*2] ;(R/E)CX = protocol name
mov peax,pdword [pebp+psize*3] ;(R/E)AX = Unique Id of the Listensession
test peax,peax
jz noUniqueIdGiven1

mov pebx,subkeyListenSession        ;subkey  'ListenSessions'

;create room on stack to convert the uniqueId to string
if used is32
  sub pesp,0xC
else
  sub rsp,0x28
end if
mov pedx,pesp ;(R/E)DX = pointer to string with unique number

push 0x10
push pedx
push peax ;the unique number
call IntToStr

noUniqueIdGiven1:
mov pesi,subkeyByString
mov pedi,pdword [pebp+psize*5] ;name
mov peax,pdword [pebp+psize*4] ;flags
test peax,GDPD_NAME_IS_INTEGER
jz nameIsString1

;create room on stack to convert the name to string
if used is32
  sub pesp,0xC
else
  sub rsp,0x28
end if
mov peax,pesp ;(R/E)DX = pointer to string with unique number

push 0x10
push peax
push pedi ;name
call IntToStr

mov pedi,pesp

mov pesi,subkeyById

nameIsString1:
test pedx,pedx
jnz UniqueIdIsSet1

xchg pedx,pesi ;swap the unique id (since it is not set) with the "listById" or "listByString" string
jmp UniqueIdIsNotSet1

UniqueIdIsSet1:
xchg pecx,pedx

UniqueIdIsNotSet1:
push pedi                   ;name of data
push pesi                   ;"listById" or "listByString" or null
push pedx                   ;use protocol name as sub key (or no subkey if unique id = 0)
push pecx                   ;use Unique Id as sub key (or protocol name if unique id = 0)
push pebx                   ;use "ListenSessions" or "Protocols" as subkey
push [hKey]                 ;key already opent
call DeleteRegValue

call dleave
ret psize*4

;-------------------------------------------------------------------------------
;This function will save a list to the registry
;input:
;   1: hKey
;   2: SubKey
;   3: SubSubKey
;   4: SubSubSubKey
;   5: SubSubSubSubKey
;   6: NameOfList
;   7: ValueData
;   8: ValueDataLen
;   9: ValueDataType
;
;------------------------------------------------------------------------------
WriteListReg:
call denter

push pdword [pebp+psize*6]  ;SubSubSubSubKey
push pdword [pebp+psize*5]  ;SubSubSubKey
push pdword [pebp+psize*4]  ;SubSubKey
push pdword [pebp+psize*3]  ;SubKey
push pdword [pebp+psize*2]  ;hKey
push 1                      ;create the key
call OpenRegKey
test pecx,pecx
jnz errWriteListReg

xchg peax,pecx   ;ECX = regkey to the data arrea

;delete the list currently kept in memory
push pdword [pebp+psize*7]  ;NameOfList
push pecx
call DeleteRegKey

;open regkey to the area to save the list
push 0                      ;SubSubSubSubKey
push 0                      ;SubSubSubKey
push 0                      ;SubSubKey
push pdword [pebp+psize*7]  ;NameOfList
push pecx                   ;hKey
push 1                      ;create the key
call OpenRegKey
test pecx,pecx
jnz errWriteListRegOpenSaveArea
mov pebx,peax   ;(R/E)BX = register key to the area to save the list

;close key to data arrea
push pecx
call RegCloseKeycall

mov pedx,pdword [pebp+psize*8]
mov pedx,pdword [pedx]         ;(R/E)DX = pointer to the list

;lock the list for write actions
push pedx
call LockListWriteAcces

push pedx      ;list
call CountItems
sub eax,2    ;the first two items are used for pointer MultiColumnList and ammount of items per column
mov ecx,eax  ;ECX = the ammount of rows

;get ammount of items per row
push 2
push pedx
call GetDwordItem
test peax,peax
jz errWriteListRegListAreaOpened
mov edi,eax ;EDI = ammount of items per row

;push ammount of items per row on stack
push pedi
mov pesi,pesp

;write itemsPerRow to registry
if used is32
  push REG_DWORD  ;push type for register
else
  push 11;REG_QWORD  ;push type for register
end if
push psize                  ;datalen
push pesi                   ;data
push nameItemsPerRow        ;name of data
push 0                      ;SubSubSubSubKey
push 0                      ;SubSubSubKey
push 0                      ;SubSubKey
push 0                      ;SubKey
push pebx                   ;key already opent
call WriteRegEx

add pesp,psize ;clear "ammount of items per row" from stack

test pecx,pecx
jz endWriteRowsToRegistry

;(R/E)BX = register key to the area to save the list  \
;(R/E)DX = pointer to the list
;ECX = the ammount of rows
;EDI = ammount of items per row
writeRowsToRegistry:
   ;get itemId or row
   mov eax,ecx
   add eax,2

   ;get row
   push peax
   push pedx
   call GetDwordItem
   mov pesi,peax ;(R/E)SI = pointer to row

   ;create room on stack to convert the name to string
   if used is32
      sub pesp,0xC
   else
      sub rsp,0x28
   end if
   mov peax,pesp ;(R/E)AX = pointer to string with itemId

   ;convert itemId to string
   push 0x10
   push peax
   push pecx ;name
   call IntToStr

   mov peax,pesp ;(R/E)AX = pointer to string with itemId

   push pecx ;save ECX (OpenRegKey will overwrite this param)

   ;open regkey to the area to save the list
   push 0                      ;SubSubSubSubKey
   push 0                      ;SubSubSubKey
   push 0                      ;SubSubKey
   push peax                   ;itemId
   push pebx                   ;hKey
   push 1                      ;create the key
   call OpenRegKey
   if used is64
     mov r12,peax                   ;R12 = register key to write this row too
   else
     mov pdword [pebp+psize*2],peax ;overwrite hKey with key to write this row too
   end if

   pop pecx ;pop ECX (OpenRegKey will overwrite this param)

   ;clear space on stack for the itemId string
   if used is32
      add pesp,0xC
   else
      add rsp,0x28
   end if

   if used is32
     push edi ;ammount of items per row
   else
     mov r13d,edi ;R13 = ammount of items per row
   end if

   writeRowItemsToRegistry:
     ;create room on stack to convert the itemId to string
     if used is32
        sub pesp,0xC
     else
        sub rsp,0x28
     end if
     mov peax,pesp ;(R/E)AX = pointer to string with itemId

     ;convert itemId to string
     push 0x10
     push peax
     if used is32
       mov eax,dword [pesp+psize*2+0xc] ;total items
       sub eax,edi                    ;total items per row - current item = id
     else
       mov eax,edi    ;total items
       sub eax,r13d   ;total items per row - current item = id
     end if
     push peax ;name
     call IntToStr

     lodsp ;get the size of the item
     test peax,peax
     jnz itemIsPointer

     if used is32
       push REG_DWORD  ;push type for register
     else
       push 11;REG_QWORD  ;push type for register
     end if
     push psize ;push size of a integer
     push pesi  ;push pointer to integer
     lodsp ;skip pointer to data
     jmp itemWasInteger

     itemIsPointer:
     push REG_BINARY  ;push type for register
     push peax ;push the size of the item we want to write to registry

     lodsp ;get pointer to data
     push peax ;push the pointer to the item we want to write to registry

     itemWasInteger:
     mov peax,pesp
     add peax,psize*3  ;(R/E)AX = pointer to string with itemId

     push peax                    ;name of data
     push 0                      ;subsubsubsubKey
     push 0                      ;subsubsubKey
     push 0                      ;subsubKey
     push 0                      ;subKey
     if used is64
       push r12                   ;push hKey to write this row too
     else
       push pdword [pebp+psize*2] ;push hKey to write this row too
     end if
     call WriteRegEx

     ;clear space on stack for the itemId string
     if used is32
        add pesp,0xC
     else
        add rsp,0x28
     end if

     if used is32
       dec edi ;decrement the itemId
     else
       dec r13  ;decrement the itemId
     end if
   jnz writeRowItemsToRegistry

   NoRowItemsToWriteToRegistry:
   if used is32
     pop edi ;restore ammount of items per row
   end if

   if used is64
     push r12                   ;register key to write this row too
   else
     push pdword [pebp+psize*2] ;register key to write this row too
   end if
   call SafeRegCloseKeycall

   dec ecx
jnz writeRowsToRegistry

endWriteRowsToRegistry:
;lock the list for write actions
push pedx
call ExternalUnlockListWriteAcces

errWriteListRegListAreaOpened:
;close key to area to save the list
push pebx
call RegCloseKeycall
xor ecx,ecx ;clear value  (since the register key is already closed

errWriteListRegOpenSaveArea:
jecxz errWriteListReg
;close key to data arrea
push pecx
call RegCloseKeycall

errWriteListReg:
call dleave
ret

;------------------------------------------------------------------------------
;This function will save a listensession to disk
;input:
;  1:pointer Internal Listensession
;output: EAX: true / false
;------------------------------------------------------------------------------
RemoveListenSessionToDisk:
call denter

;convert the unique Id of the listensession to a string
if used is32
  sub pesp,0xC
else
  sub rsp,0x28
end if
mov pedx,pesp ;(R/E)DX = pointer to string with unique number

mov peax,pdword [pebp+psize*3]    ;internal ListenSession
mov eax,dword [peax+(5*psize)+4]  ;uniqueId of the ListenSession

push 0x10
push pedx
push peax ;the unique number
call IntToStr

;open hKey to ListenSession directory
push 0                      ;no subkey
push 0                      ;no subkey
push 0                      ;no subkey
push subkeyListenSession    ;SubKey
push pdword [hKey]  ;hKey
push 0                      ;create the key
call OpenRegKey
test pecx,pecx
jnz endRemoveListenSessionToDisk
mov pebx,peax ;safe hKey

push pesp ;unique number
push peax ;hKey
call DeleteRegKey


push pebx
call RegCloseKeycall

endRemoveListenSessionToDisk:
call dleave
ret psize

;------------------------------------------------------------------------------
;This function will save a listensession to disk
;input:
;  1:pointer ListenSession
;  2:pointer Internal Listensession
;output: EAX: true / false
;------------------------------------------------------------------------------
SaveListenSessionToDisk:
call denter

;convert the unique Id of the listensession to a string
if used is32
  sub pesp,0xC
else
  sub rsp,0x28
end if
mov pedx,pesp ;(R/E)DX = pointer to string with unique number

mov peax,pdword [pebp+psize*3]    ;internal ListenSession
mov eax,dword [peax+(5*psize)+4]  ;uniqueId of the ListenSession

push 0x10
push pedx
push peax ;the unique number
call IntToStr

mov pesi,pdword [pebp+psize*3] ;internal ListenSession

;save the listensession name as string
push pdword [pesi+(5*psize)+8+psize] ;InternalListenSession->name
call strlen

push REG_SZ
push peax                            ;datalen
push pdword [pesi+(5*psize)+8+psize] ;data  (InternalListenSession->name)
push nameListenSession               ;name of data
push 0                               ;no subKey
push 0                               ;no subKey
push pedx                            ;use Unique Id as sub key (or protocol name if unique id = 0)
push subkeyListenSession             ;"ListenSessions"
push [hKey]                          ;key already opent
call WriteRegEx

mov pesi,pdword [pesi] ;BindedTo collection

;get ammount of items in the list
push pesi
call CountItems
mov ecx,eax

mov ebx,1   ;the size of the MULTI string starts with 1

mov edx,ecx ;save the ammount of listensessions

;calculate the total size
loopBindedItems:
  ;get binded ProtocolSession
  push pecx
  push pesi
  call GetDwordItem

  ;get internal ProtocolSession
  push peax
  call getInternalProtocolStructure
  mov peax,pdword [peax+psize*2] ;(R/E)AX = copyPsess
  mov peax,pdword [peax+psize]   ;(R/E)SI = name
  push peax                      ;push the name for later use

  ;calculate the size of the string
  push peax
  call strlen
  inc peax      ;add zero terminator
  push peax     ;push size
  add pebx,peax ;add the size to total
loop loopBindedItems

mov ecx,edx ;restore the size (equal to pushed items on stack)

;allocate memory for the multi string
push pebx
call GetMemLocation
mov pedi,peax

mov eax,ecx ;save counter pushed size and protocolnames

copyProtocolNames:
  mov edx,ecx ;save counter

  pop pecx ;restore the size of the protocol name
  pop pesi ;restore the protocol name
  rep movsb ;copy the string

  mov ecx,edx ;restore counter

loop copyProtocolNames

mov pedx,pesp ;(R/E)DX = pointer to string with unique number
;mov ecx,eax ;restore counter pushed size and protocolnames
;-if used is32
;-  shl eax,3 ;counter = counter * 8
;-else
;-  shl eax,4 ;counter = counter * 16
;-end if
;-sub pesp,peax   ;restore the pushed size and protocolnames

;copy terminating zero byte
xor al,al
stosb

sub pedi,pebx ;restore begin pointer

;save the protocol names as string sapperated by zero bytes
push REG_MULTI_SZ
push pebx                   ;datalen
push pedi                   ;data
push nameBindedProtocol     ;name of data
push 0                      ;no subKey
push 0                      ;no subKey
push pedx                   ;use Unique Id as sub key (or protocol name if unique id = 0)
push subkeyListenSession    ;"ListenSessions"
push [hKey]                 ;key already opent
call WriteRegEx

push pedi
call FreeMemLocation

mov pesi,pdword [pebp+psize*2] ;ListenSession
mov pesi,pdword [pesi+8]   ;pointer to ProtocolData

loopProtocoldataInListenSession:
  lodsp ;get the size of the protocoldata structure
  mov pecx,peax
  jecxz endLoopProtocoldataInListenSession
  lodsp ;get the ProtocolSession

  sub pecx,psize*2 ;substract the size and psess member
  add pesi,pecx ;skip this ProtocolData structure
  ;--jz noProtocoldataFromThisProtocol

  ;get internal ProtocolSession
  push peax
  call getInternalProtocolStructure

  if used is32
    push dword [peax+(psize*7)+4]    ;save type   000
  else
    lea r12,dword [peax+(psize*7)+4] ;save type
  end if

  mov peax,pdword [peax+psize*2] ;(R/E)AX = copyPsess
  mov peax,pdword [peax+psize]   ;(R/E)SI = name

  ;if used is32
  ;  push peax    ;save name
  ;else
  ;  mov r13,peax ;save name
  ;end if

  ;-;save the protocoldata
  ;-push REG_BINARY
  ;-push pecx                   ;datalen
  ;-push pesi                   ;data
  ;-push nameProtocolData       ;name of data
  ;-push 0                      ;no subKey
  ;-push peax                   ;Protocol name
  ;-push pedx                   ;use Unique Id as sub key (or protocol name if unique id = 0)
  ;-push subkeyListenSession    ;"ListenSessions"
  ;-push [hKey]                 ;key already opent
  ;-call WriteRegEx

  ;-if used is32
  ;-  pop peax ;restore the name
  ;end if

  ;save the protocoldata
  push REG_DWORD
  push 4                      ;datalen
  if used is32
    push esp
    add dword [pesp],psize*2   ;push pointer to type
  else
    push r12                  ;push pointer to type
  end if
  push nameProtocolType       ;name of data
  push 0                      ;no subKey
  ;if used is64
  ;  push r13                  ;Protocol name
  ;else
    push peax                 ;Protocol name
  ;end if
  push pedx                   ;use Unique Id as sub key (or protocol name if unique id = 0)
  push subkeyListenSession    ;"ListenSessions"
  push [hKey]                 ;key already opent
  call WriteRegEx

  if used is32
    add pesp,psize  ;delete type from stack
  end if

noProtocoldataFromThisProtocol:
  ;--add pesi,pecx ;skip this ProtocolData structure
jmp loopProtocoldataInListenSession

endLoopProtocoldataInListenSession:
call dleave
ret psize*2

;------------------------------------------------------------------------------
;This function load the ListenSessions from the register
;input:
;     none
;output: EAX: true / false
;------------------------------------------------------------------------------
LoadListenSessionsFromDisk:
call denter

;enumerate the listensessions
push 0
push CallbackLoadListenSessionsFromDisk
push 0
push 0
push 0
push subkeyListenSession
push [hKey]
call EnumRegKey

call dleave
ret

;------------------------------------------------------------------------------
;This function is a callback function of EnumRegKey and will create a BindStruct
;from the registerKey and call BindTo function
;input:
;       1:hKey
;       2:param
;       3:Keyname
;output: EAX: true / false
;------------------------------------------------------------------------------
CallbackLoadListenSessionsFromDisk:
call denter

push nameBindedProtocol    ;valueName
push 0                     ;subKey
push pdword [pebp+psize*2] ;hKey
call ReadReg
;  (r/e)cx = size of pointer (r/e)ax
;  (r/e)dx = return value of RegQueryValueEx
;  (r/e)ax = Memlocation with the read data
test edx,edx
jnz endCallbackLoadListenSessionsFromDisk

xor ebx,ebx ;zero (R/E)BX
xor edx,edx ;zero (R/E)DX

mov pedi,peax ;the pointer with the value of BindedProtocol

push pedi ;save pointer returned by ReadReg

addBindedToProtocols:
  ;Make a BindStruct
  push SIZEOF_BINDSTRUCT
  call GetMemLocation

  test pebx,pebx
  cmovz pebx,peax ;set first BindStruct in the Linked-list chain
  cmovz pedx,peax ;set last BindStruct in the Linked-list chain
  jz firstBindStruct

  cmp peax,pedx
  je doNotSetNext

    mov pdword [pedx+psize+8],peax ;set member next

  doNotSetNext:
  mov pedx,peax ;(R/E)DX = last member in the linked-list chain

firstBindStruct:


  mov pdword [pedx],pedi ;set member protocolName

  push errReadRegType        ;return jump if error
  push nameProtocolType      ;protocolType
  push pedi                  ;protocolname
  push pdword [pebp+psize*2] ;hKey
  call ReadRegDwordWithErrorJump

  mov dword [pedx+psize],eax ;set member type

errReadRegType:
  if used is32
    xor eax,eax
  else
    xor r12,r12
  end if
  call getBindInitOptionFromRegistry
  if used is32
    mov pdword [pedx+psize+8+psize],peax ;set member initOptions
  else
    mov pdword [pedx+psize+8+psize],r12 ;set member initOptions
  end if

  ;next BindToProtocol
  xor ecx,ecx
  dec ecx
  xor eax,eax
  repnz scasb

  cmp byte[pedi],0
jne addBindedToProtocols

;Read out the name of the ListenSession
push nameListenSession     ;valueName
push 0                     ;subKey
push pdword [pebp+psize*2] ;hKey
call ReadReg
mov pecx,peax ;(R/E)CX => pointer to the name

push 0x10
push pdword [pebp+psize*4] ;keyName
call StrToInt
mov pedx,peax ;set unique Id

mov peax,pdword [pebp+psize*4]
mov eax,dword [peax]

push pecx             ;Name
push pebx             ;BindStruct structure
push 0                ;protocolSession
push protocolIsBinded ;return pointer
call denter
jmp BindToProtocol_internal_jump
protocolIsBinded:


;free the name of the listensession if set
test pecx,pecx
jz destructBindStruct

  push pecx
  call FreeMemLocation

destructBindStruct:
  mov pesi,pdword [pebx+psize+8+psize] ;BindInitOptions
  test pesi,pesi
  jz noBindInitOptions

  call doDestructBindInitOptions

  ;free the pointer to the BindInitOptions structure
  push pdword [pebx+psize+8+psize]
  call FreeMemLocation

  noBindInitOptions:
  mov pedx,pdword [pebx+psize+8] ;get next BindStruct

  ;free BindStruct
  push pebx
  call FreeMemLocation

  mov pebx,pedx
  test pebx,pebx
jnz destructBindStruct

;free the pointer created by ReadReg
call FreeMemLocation

endCallbackLoadListenSessionsFromDisk:
call dleave
ret psize*3

;------------------------------------------------------------------------------
;This function will destruct the  a BindInitOption structures in the BindInitOptions structure
;it will not free the BindInitOptions structure memory itself
;input:
;       ESI: pointer to BindInitOptions
;
;corupts: (R/E)CX,(R/E)SI, (R/E)AX
;
;output: none
;------------------------------------------------------------------------------

doDestructBindInitOptions:
mov ecx,dword [pesi]                 ;size of BindInitOptions
add pesi,8                           ;get first BindInitOption
sub ecx,8                            ;skip member size and flag

;destruct BindInitOptions structure
destructBindInitOptions:
  ;free member name
  lodsp

  test dword [pesi+psize+4],GDPD_NAME_IS_INTEGER
  jnz nameIsNotAPointer

  push peax
  call FreeMemLocation

nameIsNotAPointer:
  test dword [pesi+psize+4],GDPD_IS_LIST
  jz valueIsNotAList

  lodsp ;get pointer to Row structure
  push peax
  call deleteRowStructureWithGarbageCollection
  jmp valueIsAList

valueIsNotAList:
  ;free data member
  lodsp
  push peax
  call FreeMemLocation

valueIsAList:
  add pesi,8 ;skip len and flags
  sub ecx,(psize*2)+8
jnz destructBindInitOptions
ret

;------------------------------------------------------------------------------
;This function will create a BindInitOptions structure out a registry
;input:
;       [pebp+psize*2]: hKey
;       (R/E)DI: subKey protocolname
;
;corupts: (R/E)CX,(R/E)AX, R12(x64)
;
;output: EAX (x86) or R12 (x64): BindInitOption,
;------------------------------------------------------------------------------
getBindInitOptionFromRegistry:
  ;get the ammount of options by Id
  push 0                     ;no subkey
  push 0                     ;no subkey
  push subkeyById            ;subKey 'listById'
  push pedi                  ;subKey protocolname
  push pdword [pebp+psize*2] ;hKey
  call RegAmmountOfValues
  mov pecx,peax ;The ammount of options by Id

  ;get the ammount of lists by Id
  push 0                     ;no subkey
  push 0                     ;no subkey
  push subkeyById            ;subKey 'listByString'
  push pedi                  ;subKey protocolname
  push pdword [pebp+psize*2] ;hKey
  call RegAmmountOfKeys
  add pecx,peax ;The ammount of options by String

  ;get the ammount of options by String
  push 0                     ;no subkey
  push 0                     ;no subkey
  push subkeyByString        ;subKey 'listByString'
  push pedi                  ;subKey protocolname
  push pdword [pebp+psize*2] ;hKey
  call RegAmmountOfValues
  add pecx,peax ;The ammount of options by String

  ;get the ammount of lists by String
  push 0                     ;no subkey
  push 0                     ;no subkey
  push subkeyByString        ;subKey 'listByString'
  push pedi                  ;subKey protocolname
  push pdword [pebp+psize*2] ;hKey
  call RegAmmountOfKeys
  add pecx,peax ;The ammount of options by String
  if used is64
    cmovz r12,rax
  end if
  jz noOptionsToLoad

  ;calculate the total size of all the BindInitOption structures
  if used is32
    shl pecx,4 ;ECX = ECX * 16
  else
    ;(ECX*24) == (ECX*32) - (ECX*8)
    mov peax,pecx
    shl pecx,5 ;ECX = ECX * 32
    shl peax,3 ;EAX = EAX * 8
    sub pecx,peax
  end if

  ;add the size and flag param to get the size of BindInitOptions structure
  add pecx,8

  ;Create BindInitOptions structure
  push pecx
  call GetMemLocation
  mov dword [peax],ecx ;set size member

  if used is32
    push peax
  else
    mov r12,peax
  end if

  ;enumerate the ammount of options by String
  push peax                                 ;param callback function
  push CallbackFillBindInitOptionByString   ;callback function
  push 0                                    ;no subkey
  push 0                                    ;no subkey
  push subkeyByString                       ;subKey 'listByString'
  push pedi                                 ;subKey protocolname
  push pdword [pebp+psize*2]                ;hKey
  call EnumRegValue

  if used is32
    pop peax
    push peax
  end if

  ;enumerate this list for this ListenSession and load into memory
  if used is32
    push peax                               ;param callback function
  else
    push r12                                ;param callback function
  end if
  push CallbackLoadListInBindInitOptionsByString
  push 0
  push 0
  push subkeyByString                       ;subKey 'listByString'
  push pedi                                 ;subKey protocolname
  push pdword [pebp+psize*2]                ;hKey
  call EnumRegKey

  if used is32
    pop peax
    push peax
  end if

  ;enumerate the ammount of options by Id
  if used is32
    push peax                               ;param callback function
  else
    push r12                                ;param callback function
  end if
  push CallbackFillBindInitOptionById       ;callback function
  push 0                                    ;no subkey
  push 0                                    ;no subkey
  push subkeyById                           ;subKey 'listByString'
  push pedi                                 ;subKey protocolname
  push pdword [pebp+psize*2]                ;hKey
  call EnumRegValue

  if used is32
    pop peax
    push peax
  end if

  ;enumerate this list for this ListenSession and load into memory
  if used is32
    push peax                               ;param callback function
  else
    push r12                                ;param callback function
  end if
  push CallbackLoadListInBindInitOptionsById
  push 0
  push 0
  push subkeyById                           ;subKey 'listByString'
  push pedi                                 ;subKey protocolname
  push pdword [pebp+psize*2]                ;hKey
  call EnumRegKey

  if used is32
    pop peax
  end if

noOptionsToLoad:
ret

;------------------------------------------------------------------------------
;This function is a callback function of EnumRegKey and will load a list in the
;BindInitOptions structure (by string)
;input:
;       1:hKey
;       2:param
;       3:Keyname
;output: EAX: true / false
;------------------------------------------------------------------------------
CallbackLoadListInBindInitOptionsByString:
call denter

mov pesi,pdword [pebp+psize*3] ;param (pointer to BindInitOptions)
add pesi,8                     ;skip to first BindInitOption

findEmptyBindInitOptionsByString:
  lodsp
  test peax,peax
  jz foundEmptySpotForListByString

  add pesi,psize+8 ;skip this BindInitOption
jmp findEmptyBindInitOptionsByString

foundEmptySpotForListByString:
  sub pesi,psize

 push pdword [pebp+psize*4] ;Keyname
 call copyStringA
  mov pdword [pesi],peax ;fill in member name

  mov dword [pesi+psize*2],psize ;fill in member len
  mov dword [pesi+(psize*2)+4],GDPD_IS_LIST ;fill in member flags

  lea peax,dword [pesi+psize-8]

  ;enumerate the rows for this list and load into memory
  push peax  ;param (pointer to Row structure)
  push CallbackFillRowStructure
  push 0
  push 0
  push 0
  push 0
  push pdword [pebp+psize*2] ;hKey
  call EnumRegKey

endCallbackLoadListInBindInitOptionsByString:
call dleave
ret psize*3

;------------------------------------------------------------------------------
;This function is a callback function of EnumRegKey and will load a list in the
;BindInitOptions structure (by Id)
;input:
;       1:hKey
;       2:param
;       3:Keyname
;output: EAX: true / false
;------------------------------------------------------------------------------
CallbackLoadListInBindInitOptionsById:
call denter

mov pesi,pdword [pebp+psize*3] ;param (pointer to BindInitOptions)
add pesi,8                     ;skip to first BindInitOption

findEmptyBindInitOptionsById:
  lodsp
  test peax,peax
  jz foundEmptySpotForList

  add pesi,psize+8 ;skip this BindInitOption
jmp findEmptyBindInitOptionsById

foundEmptySpotForList:
  sub pesi,psize

  push 0x10
  push pdword [pebp+psize*4] ;Keyname
  call StrToInt

  mov pdword [pesi],peax ;fill in member name
  mov dword [pesi+psize*2],psize ;fill in member len
  mov dword [pesi+(psize*2)+4],GDPD_NAME_IS_INTEGER or GDPD_IS_LIST ;fill in member flags

  lea peax,dword [pesi+psize-8]

  ;enumerate the rows for this list and load into memory
  push peax  ;param (pointer to Row structure)
  push CallbackFillRowStructure
  push 0
  push 0
  push 0
  push 0
  push pdword [pebp+psize*2] ;hKey
  call EnumRegKey

endCallbackLoadListInBindInitOptions:
call dleave
ret psize*3

;------------------------------------------------------------------------------
;This function is a callback function of EnumRegKey and will load all rows in the
;Row structure
;input:
;       1:hKey
;       2:param  (pointer to Row structure)
;       3:Keyname
;output: EAX: true / false
;  param: Filled in Row structure with a garbageCollection at Row+[size member] position
;         garbageCollection structure:
;                size member-psize
;                pointers []
;------------------------------------------------------------------------------
CallbackFillRowStructure:
call denter

mov pebx,pdword [pebp+psize*3] ;(R/E)BX = pointer to Row structure

findEmptyRowSpot:
 add pebx,8
 mov peax,pdword [pebx] ;(R/E)AX = member nextRow
 test peax,peax
 cmovnz pebx,peax       ;(R/E)BX = next row structure if member nextRow is not zero
jnz findEmptyRowSpot

;get the ammount of values in for this row
push 0                     ;no subkey
push 0                     ;no subkey
push 0                     ;no subkey
push 0                     ;no subkey
push pdword [pebp+psize*2] ;hKey
call RegAmmountOfValues

if used is64
  shl eax,3 ;multiply by 8 (to get the array for pointers)
else
  shl eax,2 ;multiply by 2 (to get the array for pointers)
end if

add peax,8+psize+psize ;add the size of the size, id & nextRow member (and the shadow pointer for created pointer, to be able to delete them aftherwards)

;create new Row structure
push peax ;size for structure Row

push peax ;size for structure Row
call GetMemLocation
mov pdword [pebx],peax  ;set member nextRow
mov pebx,peax           ;(R/E)BX = new Row structure

;create second pointer to keep track of the created pointers (a garbageCollection to to be able to delete later)
;push size (already done)
call GetMemLocation

mov pdword [pebx+8+psize],peax  ;save this garbageCollection structure in the unused 'last' member

mov dword [pebx],8+psize ;fill in size member (for the member size, id & nextRow

;enumerate the items for this row
push pebx                                 ;param (pointer to Row structure)
push CallbackFillItemMemberOfRow          ;callback function
push 0                                    ;no subkey
push 0                                    ;no subkey
push 0                                    ;no subkey
push 0                                    ;no subkey
push pdword [pebp+psize*2]                ;hKey
call EnumRegValue

call dleave
ret psize*3

whereIsTheFault:
ret psize*6

;------------------------------------------------------------------------------
;This function is a callback function of EnumRegValue and will fill in the
;item[] member of the structure Row
;
;input:
;       1:hKey
;       2:param  (pointer to Row structure)
;       3:valueName
;       4:value
;       5:valueSize
;       6:valueType
;output: EAX: true / false
;------------------------------------------------------------------------------
CallbackFillItemMemberOfRow:
call denter

mov pedi,pdword [pebp+psize*3] ;(R/E)DI = pointer to Row structure
mov eax,dword [pedi]           ;get size member
add dword [pedi],psize         ;increase the size member
add pedi,peax                  ;add size member to the row pointer to get empty spot for new item

mov pedx,pdword [pedi]         ;get garbageCollection
mov pdword [pedi+psize],pedx   ;move garbageCollection to the next free spot

mov peax,pdword [pebp+psize*5] ;EAX = value
mov pecx,pdword [pebp+psize*7] ;ECX = valueType
cmp ecx,REG_DWORD
je isDorQwordCallbackFillItemMemberOfRow

cmp ecx,11 ;REG_QWORD
jne isBinaryData

isDorQwordCallbackFillItemMemberOfRow:
mov peax,pdword [peax]         ;(D/Q)word
stosp                          ;Store the D or Qword in the Item member
jmp endCallbackFillItemMemberOfRow

isBinaryData:
push pdword [pebp+psize*6]      ;valueSize
push peax                       ;value
call copyBuffer
stosp    ;store pointer of data

add pdword [pedx],psize ;increase the 'size' member of the garbageCollection
add pedx,pdword [pedx]
mov pdword [pedx],peax  ;save pointer in garbageCollection

endCallbackFillItemMemberOfRow:
call dleave
ret psize*6

;------------------------------------------------------------------------------
;This function is a callback function of EnumRegValue and will fill the
;BindInitOption structure wwith items by Id
;
;input:
;       1:hKey
;       2:param  (pointer to BindInitOptions)
;       3:valueName
;       4:value
;       5:valueSize
;       6:valueType
;output: EAX: true / false
;------------------------------------------------------------------------------
CallbackFillBindInitOptionById:
call denter

mov pesi,pdword [pebp+psize*3] ;param (pointer to BindInitOptions)

if used checkOnBufferOverflow
  lodsd                           ;get size
  mov ecx,eax                     ;ECX
  add pesi,4                      ;skip flags member
else
  add pesi,8                      ;skip size and flag member
end if

findEmptyBindInitOptions:
  lodsp
  test peax,peax
  jz foundEmptySpot

  add pesi,psize+8 ;skip this BindInitOption

if used checkOnBufferOverflow
  sub ecx,(psize*2) + 8
  ja findEmptyBindInitOptions
else
  jmp findEmptyBindInitOptions
end if

foundEmptySpot:
 sub pesi,psize

 push 0x10
 push pdword [pebp+psize*4] ;valuename
 call StrToInt

 mov pdword [pesi],peax ;fill in member name

 mov pecx,pdword [pebp+psize*6] ;valueSize
 mov dword [pesi+psize*2],ecx ;fill in member len

 push pecx                  ;valueSize
 push pdword [pebp+psize*5] ;value
 call copyBuffer
 mov pdword [pesi+psize],peax ;fill in member data

 mov dword [pesi+(psize*2)+4],GDPD_NAME_IS_INTEGER ;fill in member flags

call dleave
ret psize*6

;------------------------------------------------------------------------------
;This function is a callback function of EnumRegValue and will fill the
;BindInitOption structure wwith items by String
;
;input:
;       1:hKey
;       2:param    (pointer to BindInitOptions)
;       3:valueName
;       4:value
;       5:valueSize
;       6:valueType
;output: EAX: true / false
;------------------------------------------------------------------------------
CallbackFillBindInitOptionByString:
call denter

mov pesi,pdword [pebp+psize*3] ;param (pointer to BindInitOptions)
add pesi,8                     ;skip to first BindInitOption

findEmptyBindInitOptionsString:
  lodsp
  test peax,peax
  jz foundEmptySpotString

  add pesi,psize+8 ;skip this BindInitOption
jmp findEmptyBindInitOptionsString

foundEmptySpotString:
 sub pesi,psize

 push pdword [pebp+psize*4] ;valuename
 call copyStringA
 mov pdword [pesi],peax ;fill in member name

 mov pecx,pdword [pebp+psize*6] ;valueSize
 mov dword [pesi+psize*2],ecx ;fill in member len

 push pecx                  ;valueSize
 push pdword [pebp+psize*5] ;value
 call copyBuffer
 mov pdword [pesi+psize],peax ;fill in member data

 mov dword [pesi+(psize*2)+4],0 ;fill in member flags

call dleave
ret psize*6